// **************************
// I2C Compass HMC5843 
// **************************
// I2C adress: 0x3C (8bit)   0x1E (7bit)
// principle:
// 1)
#if defined(HMC5843)
static uint8_t rawADC_HMC5843[6];

void i2c_Mag_init() { 
  delay(100);
  i2c_rep_start(0X3C+0);      // I2C write direction 
  i2c_write(0x02);            // Write to Mode register
  i2c_write(0x00);            //   Continuous-Conversion Mode

  magPresent = 1;  
}

void i2c_Mag_getADC () {
  static uint32_t t;
  
  if ( (micros()-t )  < 100000 ) return; //each read is spaced by 100ms
  t = micros();

  TWBR = ((16000000L / 400000L) - 16) / 2; // change the I2C clock rate to 400kHz
  
  i2c_rep_start(0X3C);     // I2C write direction
  i2c_write(0X03);         // Start multiple read
  i2c_rep_start(0X3C +1);  // I2C read direction => 1
  for(uint8_t i = 0; i < 5; i++) {
    rawADC_HMC5843[i]=i2c_readAck();}
  rawADC_HMC5843[5]= i2c_readNak();

  magADC[PITCH] =   ((rawADC_HMC5843[2]<<8) | rawADC_HMC5843[3]);
  magADC[ROLL]  =   ((rawADC_HMC5843[0]<<8) | rawADC_HMC5843[1]);
  magADC[YAW]   = - ((rawADC_HMC5843[4]<<8) | rawADC_HMC5843[5]);
}
#endif


